#ifndef VECT2_H_
#define VECT2_H_
#include <math.h>
class Vect2 {
public:
	float x;
	float y;
//	  float z;
	// for internal calculations //
//	  float[] arr= ;
	//////////////////
	// CONSTRUCTORS //
	//////////////////
	Vect2();
	Vect2(float x, float y);
//	Vect2( Vect2 &p2){
//		x = p2.x;
//		y = p2.y;
//	};
	Vect2(float angle);
	////////////////
	// PROPERTIES //
	////////////////
	bool isZero();
	bool isAlmostZero();
	bool isGreaterThan(float magnitude);
	bool isGreaterThan(int magnitude);
	bool isLessThan(float magnitude);
	bool isLessThan(int magnitude);
	bool equals(Vect2 vector);
	////////////////
	// BASIC MATH //
	////////////////
	void scale(float multiplier);
	void scale(float multX, float multY);
	void scale(Vect2 multVect);
	Vect2 scaled(float multiplier);
	Vect2 scaled(float multX, float multY);
	Vect2 scaled(Vect2 multVector);
	void divide(float divider);

	Vect2 divided(float divider);
	float dot(Vect2 a);
	float distance(Vect2 vector2);
	float squareDistance(Vect2 vector2);
	void add(float x, float y);
	void add(Vect2 vector);
	Vect2 added(float x, float y);
	Vect2 added(Vect2 vector);
	void subtract(float x, float y);
	void subtract(Vect2 vector);
	Vect2 lerped(Vect2 vector, float t);
	Vect2 subtracted(float x, float y);
	Vect2 subtracted(Vect2 vector);
	///////////////
	// MAGNITUDE //
	///////////////
	float magnitude();
	float squareMagnitude();
	void normalize();
	Vect2 normalized();
	void setMagnitude(float magnitude);
	void clip(float maximum);
	Vect2 clipped(float maximum);
	//////////////
	// ROTATION //
	//////////////
	float angle();
	void rotate(float deltaAngle);
	Vect2 rotated(float deltaAngle);
	Vect2 rotatedAround(Vect2 position, float deltaAngle);
	void rotateAround(Vect2 position, float deltaAngle);
	void setRotation(float angle);
	void rotateRight();
	Vect2 rotatedRight();
	void rotateLeft();
	Vect2 rotatedLeft();
	void flip();
	Vect2 flipped();
	Vect2 flippedX();
	Vect2 flippedY();
	/////////////
	// HELPERS //
	/////////////
	void set(float x, float y);
	void set(Vect2 v);
	void setZero();
	Vect2 copy();
	bool isValid();
//	  String toString();
	//////////////////
	// STATIC TOOLS //
	//////////////////
//	static:
	constexpr static  float ZWO_PI = (float) ( M_PI * 2.);
	static float distance(Vect2 vector1, Vect2 vector2);
	static float dot(Vect2 vector1, Vect2 vector2);
	static Vect2 lerp(Vect2 begin, Vect2 end, float interpolator);
	static float angleBetween(Vect2 vector1, Vect2 vector2);
	static float angleBetweenUnits(Vect2 vector1, Vect2 vector2);
//	   Vect2 fromString(String data);

	virtual ~Vect2(){};
};

#endif /* VECT2_H_ */
